CdmUserHelper caches permission information
09/21/2018 04:25 PM - Andreas Kohlbecker

Status: Closed Start date:
Priority: Priority14 Due date:
Assignee: Andreas Kohlbecker % Done: 100%
Category: cdm-vaadin Estimated time: 0:00 hour
Target version: Release 5.4
Severity: normal
Description
CdmUserHelper has been identified being hostspot in the cpu time analysis:
= eu.etaxonomy.vaadin.ui.navigation. NavigationManagerBean.navigateTo(String) NavigationMan a 19,709 4% 19,709 1
= com.vaadin.navigator.Navigator.navigateTo(String) Navigator.java 19,709 4% 19,709 1t 1
= com.vaadin.navigator.Navigator.navigateTo(View, String, String) ava 19,651 4% 19,651 1
= eu.etaxonomy.cdm.vaadin.view.registration. ReglstratmanrksetVlewEIean enter(VlawChangeLlStsnsr$\ﬂewchangeEvent) Bear 19,647 4% 19,647 1
= eu.etaxonomy.cdm.vaadin.view.registration. RegistrationWorkingsetPresenter.handleViewEntered() 19,646 4% 19,646 1
= eu.etaxonomy.cdm.vaadin view.registration. RegistrationWorkingsetPresenter.applyWorkingset() Feg 156,244 15,244 1
= eu.etaxonomy.cdm.vaadin view.registration. RegistrationWorksetViewBean. setWorklngset(ReglstratmanrkmgSet) e = 13,803 3 13,803 1
= eu.etaxonomy.cdm.vaadin view.registration. RegistrationWorksetViewBean. createReg|strat|onsL|5t(ReglstratlonWorklngSe tio ew 12,490 2% 12,490 1
= eu.etaxonomy.cdm.vaadin view.registration. RegistrationWorksetViewBean. putRegistrationListComponent{int, Reglstrat\unDTD) Reg e 12,481 2% 960 13
Back Traces | Callees List | Merged Callees
© Merged callees for method selected in the upper table

Merged Call Tree Time (ms) | Own Time (ms) | Invocation Count

= M eu.etaxonomy.cdm.vaadin.view.registration.RegistrationWorksetViewBean putRegistrationListComponent(int, RegistrationDTQ) R 1 13
E % eu.etaxonomy.cdm.vaadin.component.registration. RegistrationlitemNameAndTypeButtons. <init=>(RegistrationDTO) Registrat 13
= % eu.etaxonomy.cdm.api.utility. CdmUserHelper.userHasPermission(Class, UUID, Object[]) CdmUserHelper.java 0.1 13
= 2 com.sun.proxy.$Proxy166.find(Class, UUID) 39 13

% eu.etaxonomy.cdm.api.service.CommonServicelmpl find(Class, UUID) CommonServic —Im| = 0.1 13

% com.mchange.v2.c3p0.impl.NewProxyConnection. setAutuCummlt(buu\ean) ava 0.1 26

% com.mchange.v2.c3p0.impl.NewProxy Connection.close() NewPraxyConnectio 2 26

[ % com.mchange.v2.c3p0.impl.AbstractPoolBackedDataSource. getCnnnect 4 26

% com.mchange.v2.c3p0.impl. NewProxy Connection.commit() = K 1 13

% eu.etaxonomy.cdm.model.agent.Institution_$$_jvst6f0 9. getHlbernateLazylmt 1 1 13

% eu.etaxonomy.cdm.model.name. TaxonName_$$_jvst6f0_8.getHibernatel azylni a 13

% com.mchange.v2.c3p0.impl. NewProxy Connection.isClosed() = 26

% com.mchange.v2.c3p0.impl.NewProxyConnection.getAutoCommit{) 13

b ] commchange.vz.c3p0‘\mpI‘AbstractldentityTukenized‘hashCude() a 26

% com.mchange.v2.c3p0.impl.NewProxy Connection.getWarnings() lie 26

% com.mchange.v2.c3p0.impl.NewProxyConnection. (IearWarnlngE() a 0.1 26

W eu.etaxonomy.cdm.api.application. CdmRepas|tory$$EnhancerBySprlngCGLIB$$4c69f4b getCammanSenﬂce() e go4 7 13

% eu.etaxenomy.cdm.persistence. hibernate.permission. CdmPermissionEvaluator.hasPermission(Authentication, CdeSES numSet) CdmPermissio 12 13

M eu.etaxonomy.cdm. api.utility. CdmUserHelper.crudSetFromArgs(Object[]) CdmUserHelpe 0.4 13

M eu.etaxonomy.cdm. api.utility. CdmUserHelper.getAuthentication() Cdm 1 1 13

% eu.etaxonomy.cdm.vaadin.component. registration. RegistrationitemNameAndTypeButtons.addDefaultStyles() f= emNameAndTypeB s java 18 1 13
W eu.etaxonomy.cdm. api.utility. CdmUserHelper.userHasPermission(CdmBase, Object[]) CdmUserHelper.java 13 1 13
m imua bl Linkeadl ict€l ictitr farEachRamaininaiCansimar) | inkadl st iaus n 1 11

Caching entities or permsisson check results may help improving the performance.

In the analyzed case it takes 12 seconds in total to build the RegistrationWorkingsetView. 8,3 seconds of that are only used to find
entities which are needed to do permission checks. Finding these entities involves querying the database which naturally takes some
time. But these roundtrips to the DB are completely dispensable since the entities needed for the checks have been loaded already.
They are stored in the CdmTransientEntityCache which is used by the CachingPresenters. Therefore this performance overhead
culd be completely cropped off by using the cached enities.

When the permission check is being done, the entityType and UUID are known, but with this information it is not possible to query
the CdmTransientEntityCache for a cached object. The cache uses the entity.ID instead of the uuid. In #7709 the idea of using the
uuid instead of the id is being discussed.

We (AK & AM) decided for the following solution:

A subclass of the CdmTransientEntityCache will complements the CdmTransientEntityCache by the ability to get CDM entities from
the cache by the UUID. Internally a Map will be used to store the entity UUID together with the CdmEntityCacheKey of each entity
being put into the cache.

Related issues:
Related to EDIT - bug #7709: CdmTransientEntityCacher cannot handle multiple ... Feedback

Associated revisions

Revision 8bbd4f27 - 10/15/2018 12:04 PM - Andreas Kohlbecker
https://dev.e-taxonomy.eu/redmine/issues/7709

fix #7785 CdmUserHelper can use ICdmEntityUuidCacher to avoid loading entities from the db for permission checks:

- inner class CachingCdmUserHelper to be used when CdmUserHelper.withCache() is called

- ICdmEntityUuidCacher and CdmTransientEntityAndUuidCacher complements the CdmTransientEntityCacher by the ability to get CDM entities from
the cache by the UUID

Revision 67bf2db8 - 10/15/2018 03:47 PM - Andreas Kohlbecker

ref #7785 preliminary commit

Revision 3b278eb0 - 10/15/2018 03:47 PM - Andreas Kohlbecker
ref #7785 using CdmTransientEntityAndUuidCacher to promote using the CachingCdmUserHelper

Revision 4dadd125 - 11/14/2018 02:23 PM - Andreas Kohlbecker

ref #7785 fixing usage of wrong cacher method which prevented from caching the whole object graph

History

#1 - 09/21/2018 04:25 PM - Andreas Kohlbecker
- Tags changed from phycobank to phycobank, performance

#2 - 09/21/2018 04:33 PM - Andreas Kohlbecker

Can the cache of the presenter be used in the CdmUserHelper to avoid loading the entities again?

#3 - 10/08/2018 11:55 AM - Andreas Kohlbecker
- Priority changed from New to Highest

#4 - 10/09/2018 05:02 PM - Andreas Kohlbecker
- Blocked by bug #7709: CdmTransientEntityCacher cannot handle multiple unpersisted entities of the same type added

#5 - 10/09/2018 06:26 PM - Andreas Miiller

Can you define what functionality is exactly needed from the CdmTransientEntityCacher and why #7709 needs to be fixed for this. Currently it is not
planned to "fix" #7709 as it seems not to be needed for standard usecases and the new implementation is worse for in terms of memory.

#6 - 10/10/2018 08:42 AM - Andreas Kohlbecker

- Description updated

Answer is in the updated description.

#7 - 10/15/2018 12:05 PM - Andreas Kohlbecker
- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset cdmlib|8bbd4{27e47a00d244480b4f5a01056d415bda27.

#8 - 10/15/2018 12:55 PM - Andreas Kohlbecker
- Description updated

- Assignee changed from Andreas Kohlbecker to Andreas Mliller

Implemented and description updated.

#9 - 10/24/2018 05:24 PM - Andreas Miller

Sorry, currently | don't have time for review. But if it works for you review is not critical | think.

#10 - 10/24/2018 05:37 PM - Andreas Miiller
- Priority changed from Highest to Priority14

#11 - 11/14/2018 02:51 PM - Andreas Kohlbecker
- Assignee changed from Andreas Miiller to Andreas Kohlbecker

- % Done changed from 50 to 100
https://dev.e-taxonomy.eu/redmine/issues/7709
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/cdmlib/revisions/8bbd4f27e47a00d244480b4f5a01056d415bda27

The CachingCdmUserHelper effectively brings a performance boost of ~2 seconds for the big working set "Kulikovskiy, M., Lange-Bertalot, H. &
Kuznetsova, I. V., Lake Baikal: Hotspot of endemic diatoms Il.Iconographia Diatomologica, 26: [1]-656. 2015" with over 70 acts which takes ~14
seconds to load

Another hotspot is the checking for active messages in the redmine instance used for communication. This imposes mur than 5 seconds!

This issue definitely can be closed as completed. Since CdmTransientEntityAndUuidCacher has been implemented the issue #7709 is no longer
blocking this task.

#12 - 11/14/2018 02:51 PM - Andreas Kohlbecker
- Blocked by deleted (bug #7709: CdmTransientEntityCacher cannot handle multiple unpersisted entities of the same type)

#13 - 11/14/2018 02:51 PM - Andreas Kohlbecker
- Related to bug #7709: CdmTransientEntityCacher cannot handle multiple unpersisted entities of the same type added

#14 - 11/14/2018 02:52 PM - Andreas Kohlbecker

- Status changed from Resolved to Closed

Files
